<?php

namespace Fufle\Database;

use PDO;
use Fufle\Database\QueryData;

class ConnectionManager {
    private static $connection;

    public static function connect(string $connectionString) {
        self::$connection = new PDO($connectionString);
    }

    public static function Query(string $query, array|object $params = [], string $output = 'stdObject') {
        $data = new QueryData($query, $params);
        $data->normalize();
        $stmt = self::$connection->prepare($data->query);
        $stmt->execute($data->params);
        $stmt->setFetchMode(PDO::FETCH_CLASS, $output);
        return $stmt->fetch();
    }

    public static function QueryAll(string $query, array|object $params = [], string $output = 'stdObject') {
        $data = new QueryData($query, $params);
        $data->normalize();
        $stmt = self::$connection->prepare($data->query);
        $stmt->execute($data->params);
        $stmt->setFetchMode(PDO::FETCH_CLASS, $output);
        return $stmt->fetchAll();
    }
}